function [f,F] = asymstab(xvec,a,b)
% [f,F] = asymstab(xvec,a,b)

% use this for plotting the integrand
%x=xvec; dopdf=1; uvec=0.001:0.001:0.999; I=fff(uvec,x,a,dopdf); plot(uvec,I)                   

bordertol=1e-8; lo=bordertol; hi=1-bordertol; tol=1e-7;
xl=length(xvec); F=zeros(xl,1); f=F;
for loop=1:length(xvec)
  x=xvec(loop); dopdf=1;
  f(loop)= quadl(@fff,lo,hi,tol,[],x,a,b,1) / pi;
  if nargout>1
    F(loop)=0.5-(1/pi)* quadl(@fff,lo,hi,tol,[],x,a,b,0);
  end
end;


function I=fff(uvec,x,a,b,dopdf);
subs=1;
for ii=1:length(uvec)
  u=uvec(ii);  
  if subs==1, t =(1-u)/u; else, t =u/(1-u); end
  if a==1
    cf = exp(  -abs(t)*( 1 + i*b*(2/pi)*sign(t) * log(t) ) );
  else
    cf = exp(  - ((abs(t))^a) *( 1 - i*b*sign(t) * tan(pi*a/2) ) );
  end    
  z  = exp(-i*t*x) .* cf;
  if dopdf==1, g=real(z); else g=imag(z)./t; end
  if subs==1, I(ii)=g*u^(-2); else, I(ii)=g*(1-u)^(-2); end
end
