function biv=bivorder(xvec,yvec,n,i,j)
% bivariate pdf of the ith and jth order stats (out of n), with i<j
% evalutated at the matrix formed from the vectors x and y

lx=length(xvec); ly=length(yvec); biv=zeros(lx,ly);
logkon= gammaln(n+1) - gammaln(i) - gammaln(j-i) - gammaln(n-j+1);
for xl=1:lx
  x=xvec(xl);
  for yl=1:lx
    y=yvec(yl);
    if (x<y) & (x>0) & (y>0) % for Exp r.v.s, we need x>0 and y>0
      main=(i-1)*log(F(x)) + (j-i-1)*log(F(y)-F(x)) + (n-j)*log(1-F(y));
      main=main+log(f(x))+log(f(y)); biv(xl,yl)=exp(logkon+main);
    else  
      biv(xl,yl)=0;
    end  
  end
end    

function den=f(x) % the pdf of the underlying iid r.v.s
lambda=1; den=lambda*exp(-lambda*x);

function cdf=F(x) % the cdf of the underlying iid r.v.s
lambda=1; cdf=1-exp(-lambda*x);
