function area=bvnrectangle(mu,Sig,xmin,xmax,ymin,ymax)
% area=bvnrectangle(mu,Sig,xmin,xmax,ymin,ymax)
% computes rectangle probability of the bivariate normal distribution 

Siginv=inv(Sig); detSig=det(Sig);
area=dblquad(@bvnpdf,xmin,xmax,ymin,ymax,1e-6,@quadl,mu,Siginv,detSig);

function f=bvnpdf(xvec,y,mu,Siginv,detSig)
% multivariate normal pdf at x,y with mean mu and inverse var cov Siginv
% pass detSig as the determinant of varcov matrix Sig to save time, otherwise computed.

%f=[];
if nargin<4, detSig=1/det(Siginv); end
for xloop=1:length(xvec)
  x=xvec(xloop);
  if (x<y)
    f(xloop)=0;
  else  
    v=[x;y];
    e=(v-mu)' * Siginv * (v-mu);
    f(xloop)=exp(-e/2) / (2*pi) / sqrt(detSig);
  end  
end  
