function f = consecpmf (xvec,m,p)
% f = consecpmf (xvec,p,m)
% Computes pmf of the # of iid Bernoulli trials (with 
%    prob p) until m in a row are successes
% Uses the pmf inversion formula and the cf

xl=length(xvec); f=zeros(xl,1); tol=1e-5;
for j=1:xl
  x=xvec(j); f(j)=quadl(@fun,-pi,pi,tol,0,x,m,p);
end
f=real(f);

function I=fun(t,x,m,p)
I=exp(-i*t*x) .* cf(t,m,p) / (2*pi);

function g = cf(t,m,p) % cf
q=1-p;
if m==1
  g = p*exp(i*t) ./ (1-q*exp(i*t));
else
  kk = exp(i*t) .* cf(t,m-1,p);
  g = (p*kk) ./ (1-q*kk);
end
