function out=f11(a,b,xvec)
% out=f11(a,b,x)
% uses Butler and Wood's calibrated Laplace approximation

raw=[];
for loop=1:length(xvec)
  raw(loop)= doit(a,b,xvec(loop));
end
out= raw / doit(a,b,0);


function loc=doit(a,b,x)
  if abs(x)<1e-8
    y=a/b;
  else
    y=( (x-b) + sqrt((x-b)^2 + 4*a*x) ) / (2*x);
  end
  w=a*(1-y)^2 + (b-a)*y^2;
  loc= (1 / sqrt(w)) * y^a * (1-y)^(b-a) * exp(x*y);
  