function out=f21(a,b,c,xvec)
% out=f21(a,b,c,x)
% uses Butler and Wood's calibrated Laplace approximation
% won't work for b=c.

if abs(b-c)<1e-8, error ('Only works for b ~= c'), end

raw=[];
for loop=1:length(xvec)
  raw(loop)= doit21(a,b,c,xvec(loop));
end
out = raw / doit21(a,b,c,0);
   
function loc=doit21(a,b,c,x)
  tau=x*(b-a)-c;
  if abs(x)<1e-8
    y=a/c;
  else
    y=( tau+sqrt(tau^2-4*a*x*(c-b)) ) / ( 2*x*(b-c) );
  end
  w=a*(1-y)^2 + (c-a)*y^2 - b*x^2*y^2*(1-y)^2 / (1-x*y)^2;
  loc= (1 / sqrt(w)) * y^a * (1-y)^(c-a) / (1-x*y)^b;
  