function f=ghyppdf(x,lambda,alpha,beta,delta,mu)
% f=ghyppdf(x,lambda,alpha,beta,delta,mu)

if nargin<6, mu=0; end
if nargin<5, delta=1; end

a=alpha; b=beta; lam=lambda;  % just easier to work with
c=sqrt(a^2 - b^2); y = sqrt(delta^2 + (x-mu).^2);
t1=c^lam * y.^(lam - 0.5);
t2=sqrt(2*pi) * a^(lam-0.5) * delta^lam * besselk(lam,delta*c);
d1=besselk(lam-0.5,a*y) .* exp(b*(x-mu));
f = (t1./t2) .* d1;
