function [f,F] = mixnormcf(xvec,w,mu,s2)
% Just for fun, and an exercise in the slides to Intermediate Prob,
%   applies inversion formula to the 2-component mixed normal with
%   means mu=(mu1,mu2) and variances s2=(sigma_1^2,  sigma_2^2)
%   and weights w=(w1,w2), with the standard constraints.

bordertol=1e-8; lo=bordertol; hi=1-bordertol; tol=1e-8;
xl=length(xvec); F=zeros(xl,1); f=F;
for loop=1:length(xvec)
  x=xvec(loop); dopdf=1;
  f(loop)= quadl(@fff,lo,hi,tol,[],x,w,mu,s2,1) / pi;
  if nargout>1
    F(loop)=0.5-(1/pi)* quadl(@fff,lo,hi,tol,[],x,w,mu,s2,0);
  end
end;

function I=fff(uvec,x,w,mu,s2,dopdf);
for ii=1:length(uvec)
  u=uvec(ii);  t  = (1-u)/u;
  cf = w(1)*exp( i*t*mu(1) - (s2(1)*t.^2)/2 ) + w(2)*exp( i*t*mu(2) - (s2(2)*t.^2)/2 );  % cf
  z  = exp(-i*t*x) .* cf;
  if dopdf==1, g=real(z); else g=imag(z)./t; end
  I(ii)  = g / u^2;
end
