function pdf = ncf1pdf(xvec,nu1,nu2,theta1,k)
if nargin<5, k=0; end
if (theta1==0), pdf=fpdf(xvec,nu1,nu2); return, end
xlen=length(xvec); pdf=zeros(xlen,1);
n12=nu1/2;  n22=nu2/2; n1n22=(nu1+nu2)/2; rndtheta=round(theta1+1);
for xloop=1:xlen,   x=xvec(xloop);
  tmp=nu1*x/nu2; tmp1=tmp+1; ltmp=log(tmp); ltmp1=log(tmp1);
  up=3*rndtheta; c=0:up;   % This upper limit is often adequate...
  ppln=ppdfln(c,theta1/2);
  bbln=gammaln(n12+c)+gammaln(n22+k)-gammaln(n1n22+c+k);
  dln =  ppln - bbln + (n12+c-1)*ltmp - (n1n22+c+k)*ltmp1;
  pdf(xloop) = sum(exp(dln));
  if exp(dln(end))>1e-14 % ...but if NOT enough, use a large value.
    c=(up+1):(10*rndtheta);  ppln=ppdfln(c,theta1/2);
    bbln=gammaln(n12+c)+gammaln(n22)-gammaln(n12+c+n22);
    dln =  ppln - bbln + (n12+c-1)*ltmp - (n1n22+c)*ltmp1;
    extra = sum(exp(dln)); pdf(xloop) = pdf(xloop) + extra;
  end
end
pdf=pdf*nu1/nu2;

function y=ppdfln(x,lambda)
y = -lambda + x .* log(lambda) - gammaln(x + 1);
