function F=pan(xvec,a,N)
% F=pan(xvec,a,N)
% cdf of a'X, X_i ~iid X^2, at the values in xvec

if nargin<3, N=20; end;
a=reshape(a,length(a),1);
F=zeros(size(xvec));
yin=cos((2*cumsum(ones(N,1))-1)*pi/(2*N));
for loop=1:length(xvec)
  x=xvec(loop);
  if all(a<0)
    F(loop)=1-AS_R52(-x,-a,yin);
  else 
    F(loop)=AS_R52(x,a,yin); 
  end;
end


function[F]=AS_R52(c,lambda,yin)
lambda=-sort(-lambda); m=length(lambda);n=length(yin);
v=min(find(lambda<=0))-1;if isempty(v),v=m;end;
deltav=0.5*(1-(-1)^v);deltamv=0.5*(1-(-1)^(m-v));
F=0;
if c>=0 | (c==0 & v<=m-v)
    for j=1:floor(0.5*v)
        F=F+((-1)^j)*mean(panintegrand(yin,c,lambda,[2*j,2*j-1]));
    end;
    F=1+F;
    if deltav>0,
        F = F + (deltav)*(-1)^(0.5*(v+1)) ...
          *mean(panintegrand(yin,c,lambda,v));
    end;
else
    for j=1:floor(0.5*(m-v))
        F = F + ((-1)^j)*mean(panintegrand(...
          yin,c,lambda,[m-2*j+1,m-2*j+2]));
    end;
    if deltamv>0,
        F = F + (deltamv)*(-1)^(0.5*(m-v+1))...
          *mean(panintegrand(yin,c,lambda,v+1));
    end;
    F=-F;
end;

function I=panintegrand(tvec,c,lambda,outind)
m=length(lambda);
outnumber=length(outind);
inind=1:m;
for i=1:outnumber;
  inind=inind(find(inind~=outind(i)));
end
sv=1; if outnumber==2, sv=[1 ;-1]; end
I=zeros(size(tvec));
for tloop=1:length(tvec)
  t=tvec(tloop);
  yv=0.5*(sum(lambda(outind)))-0.5*(lambda(outind)'*sv)*t;
  if yv==0
    helper=0;
  else
    helper=(exp(-c/(2*(yv))));
  end
  I(tloop)=helper * ...
      sqrt(abs(((yv)^(m-outnumber))/prod(yv-lambda(inind))));
end;

