T=2^15; dx=0.002; % tuning parameters which influence quality

% ell is the lower limit in finite integral approximation to the c.f.
ell=-3; % use this when inverting the standard normal.
ell=0; % use 0 for the chi^2.

t=-(T/2):(T/2)-1; s = 2*pi*t/T/dx;

%%%%%%%%%%%%% Choose the c.f.  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
phi = exp(-(s.^2)/2); % the standard normal c.f.
% df=4; phi = (1-2*i*s).^(-df/2); % the chi^2(df) c.f.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

g = phi.*exp(-i*s*ell);
P=ifft(g); % Remember: in Matlab, ifft computes the DFT
pdf = P/dx;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if max(abs(imag(pdf)))>1e-7, 'problem!', end
%% There should be no imaginary part, so check for this
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
f=abs(pdf); f=f(end:-1:1); % this is necessary.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

x=ell+(dx/1):dx:T*dx; % next 2 lines in case x is off by one
if length(x)<length(f), x=[x (T+1)*dx]; end
if length(x)>length(f), x=x(1:end-1); end

xup=4; % set to around 20 for the chi^2
loc=find(diff(x>xup)); % just up to x=xup
x=x(10:loc); f=f(10:loc);

true = normpdf(x); plot(x,100*(f-true)./true)
%true = chi2pdf(x,df); plot(x,100*(f-true)./true)
