function m=stabmom(r,a,b,l,h)
% m=stabmom(r,a,b,l,h)
% absolute rth moment, E[|X|^r], where X ~ S_{a,b}

% EXACTLY
if r==1, k=pi/2; else, k=gamma(1-r)*cos(pi*r/2); end
m=gamma(1-r/a)/k;
if (b~=0)
  tau=b * tan(a*pi/2);  f1 = (1 + tau^2)^( r/(2*a) );
  f2 = cos( (r/a) * atan( tau ) );  m=m*f1*f2;
end
m
if nargin>3 % compute numerically also
  %Km=a*gamma(a)*sin(pi*a/2)*(1-b)/pi; Kp=a*gamma(a)*sin(pi*a/2)*(1+b)/pi; 
    tmp = a*gamma(a)*sin(pi*a/2)/pi; Km=tmp*(1-b); Kp=tmp*(1+b); 
  d=r-a; I=-(Km/d)*((-l)^d); III=-(Kp/d)*(h^d);
  II=quadl(@ff,l,h,1e-6,1,r,a,b); m=I+II+III;
end  

function I=ff(xvec,r,a,b) % compute |x|^r * f(x) 
I=zeros(size(xvec));
for ii=1:length(xvec)
  x=xvec(ii); f = asymstab(x,a,b); I(ii) = ((abs(x))^r) .* f;
end