function cdf = tcdfdoub(tvec,k,mu,theta)
% cdf of the doubly noncentral t

if theta==0; cdf=nctcdf(tvec,k,mu); return, end

cdf=zeros(length(tvec),1);
for tloop=1:length(tvec)
  t=tvec(tloop);
  partsum=0; inc=50; %    calculate the sum in chunks of inc to capitalize
  lo=0; hi=inc; done=0; %  on matlab's vectorized computing
  while ~done
    ivec=lo:hi;
    lnw = -theta/2 + ivec*log(theta/2) - gammaln(ivec+1);
    k2i=k+2*ivec;
    logcdfpart = log(nctcdf(t*sqrt(k2i/k),k2i,mu));
    newpartvec = exp(lnw + logcdfpart);
    newpartsum = sum(newpartvec);
    partsum = partsum + newpartsum;
    lo=hi+1; hi=hi+inc;
    if ( newpartvec(1) >= newpartvec(end) ) & ( newpartsum<1e-12 ), done=1; end
  end
  cdf(tloop) = real(partsum); % roundoff error produces imaginary component
end                           %  on the order of 1e-28. Just delete it.



